#ifndef _USER_H
#define _USER_H

/* user.h */

#ifndef TRUE
    #define TRUE 0x1
#endif

#ifndef FALSE
    #define FALSE 0x0
#endif

#define u8      unsigned char
#define u16     unsigned short
#define u32     unsigned int
#define u64     unsigned long long

typedef u8 boolean_t;

#define PIERR_NO_ERROR 0x0
#define PIERR_UNKNOWN_ERROR 0x1

#define PIERR_GENERIC_ERROR 0x100

/* generic errors */
#define PIERR_NOT_FOUND (PIERR_GENERIC_ERROR + 0)
#define PIERR_OUT_OF_MEMORY (PIERR_GENERIC_ERROR + 1)
#define PIERR_TIMEOUT (PIERR_GENERIC_ERROR + 2)
#define PIERR_FILE_NOT_FOUND (PIERR_GENERIC_ERROR + 3)
#define PIERR_NOT_SUPPORTED (PIERR_GENERIC_ERROR + 4)
#define PIERR_OPERATION_FAIL (PIERR_GENERIC_ERROR + 5)
#define PIERR_PROGRAM_ERROR (PIERR_GENERIC_ERROR + 6)
#define PIERR_BUFFER_TOO_SMALL (PIERR_GENERIC_ERROR + 7)

/* for user management */
#define MAX_PATH_LENGTH 255
#define USERDB_FILE_NAME "userdb.xml"

#define MAX_NUM_USER	16
#define MAX_USER_NAME_LENGTH 32
#define MAX_PASSWORD_LENGTH 32
#define MAX_FULL_NAME_LENGTH 40
#define MAX_EMAIL_LENGTH 48
#define MAX_NUM_EVENTID_FILTER 16
#define MAX_ENCRYPT_PASSWORD_LENGTH (MAX_PASSWORD_LENGTH*3+1)

#define ENCRYPTIONKEY_LENGTH 40
//#define EMPTY "(null)"
//string of 256 bytes for maximum length for any XML element is far more than enough
#define MAX_XML_ELEMENT_LENGTH 256

typedef struct
{   
    unsigned char ui_u8Username[MAX_USER_NAME_LENGTH];
    unsigned char ui_u8Fullname[MAX_FULL_NAME_LENGTH];
    unsigned char ui_u8Password[MAX_PASSWORD_LENGTH];
    unsigned char ui_u8PwdEncrypted[(MAX_ENCRYPT_PASSWORD_LENGTH/8+1)*8];
    unsigned char ui_u8Email[MAX_EMAIL_LENGTH];
    unsigned char ui_u8UserGroupId;
    unsigned char ui_bEnable;
    unsigned char ui_u8Reserved[6];
} user_info_t;

#endif /* _USER_H */
